//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3C17869E016B.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3C17869E016B.cm

//## begin module%3C17869E016B.cp preserve=no
//## end module%3C17869E016B.cp

//## Module: ChiSquare%3C17869E016B; Package specification
//## Subsystem: XSFit::StatMethod::ChiSquare%3C17865101B4
//## Source file: /local/data/xerxes1/gordon/oldplot/headas/Xspec/src/XSFit/StatMethod/ChiSquare/ChiSquare.h

#ifndef CHISQUARE_H
#define CHISQUARE_H 1

//## begin module%3C17869E016B.additionalIncludes preserve=no
//## end module%3C17869E016B.additionalIncludes

//## begin module%3C17869E016B.includes preserve=yes
//## end module%3C17869E016B.includes

// xsTypes
#include <main/xsTypes.h>
// string
#include <string>
// StatMethod
#include <XSFit/Fit/StatMethod.h>

class Fit;

//## begin module%3C17869E016B.declarations preserve=no
//## end module%3C17869E016B.declarations

//## begin module%3C17869E016B.additionalDeclarations preserve=yes
//## end module%3C17869E016B.additionalDeclarations


//## begin ChiSquare%3B7BFB6F0280.preface preserve=yes
//## end ChiSquare%3B7BFB6F0280.preface

//## Class: ChiSquare%3B7BFB6F0280
//## Category: XSFit::StatMethod%3FC51D1601E4
//## Subsystem: XSFit::StatMethod::ChiSquare%3C17865101B4
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3C6005F100CA;SpectralData { -> }
//## Uses: <unnamed>%3C60060E01D5;Fit { -> F}
//## Uses: <unnamed>%3C6009130338;XSContainer::Weight { -> }
//## Uses: <unnamed>%3C6009350035;Background { -> F}
//## Uses: <unnamed>%3C6027EA0120;Model { -> }

class ChiSquare : public StatMethod  //## Inherits: <unnamed>%3B7BFB9003E4
{
  //## begin ChiSquare%3B7BFB6F0280.initialDeclarations preserve=yes
  //## end ChiSquare%3B7BFB6F0280.initialDeclarations

  public:
    //## Constructors (generated)
      ChiSquare();

      ChiSquare(const ChiSquare &right);


    //## Other Operations (specified)
      //## Operation: setWeight%3C4EF5FC01BC
      //	Public virtual to set weighting  scheme. The base class
      //	implementation sets the weight scheme to "standard"
      //	and issues a warning that the statistical method doesn't
      //	recognize other weight schemes than standard (i.e.,
      //	use the variance). This will be overriden by statistics
      //	that
      //	behave like chi^2 and do admit other weightings.
      virtual void setWeight (const std::string& weightName);

      //## Operation: clone%3C84ECAC01E0
      virtual ChiSquare* clone () const;

      //## Operation: plotChi%3DD26F740268
      virtual Real plotChi (Real obs, Real mod, Real error, Real areaTime, const Real& NODATA) const;

      //## Operation: plotDeltaChi%3DD26F79017E
      virtual Real plotDeltaChi (Real obs, Real mod, Real error, const Real& NODATA) const;

      //## Operation: calcMinVariance%44A97E1F022D
      static Real calcMinVariance (Real areaTime, Real backAreaTime, Real bscaleRatio);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSFit::Fit::<unnamed>%3DD3F21300C6
      //## Role: ChiSquare::fullName%3DD3F21400EA
      virtual const std::string& fullName () const;

      //## Association: XSFit::Fit::<unnamed>%3DD4093801A8
      //## Role: ChiSquare::scriptName%3DD4093901F4
      virtual const std::string& scriptName () const;

    // Additional Public Declarations
      //## begin ChiSquare%3B7BFB6F0280.public preserve=yes
      //## end ChiSquare%3B7BFB6F0280.public

  protected:

    //## Other Operations (specified)
      //## Operation: getWeightDerivs%416EB17902EB
      virtual void getWeightDerivs (Fit* fit);

    // Additional Protected Declarations
      //## begin ChiSquare%3B7BFB6F0280.protected preserve=yes
      //## end ChiSquare%3B7BFB6F0280.protected

  private:

    //## Other Operations (specified)
      //## Operation: doReport%3C90CF3F01F9
      virtual void doReport (Fit* fit) const;

      //## Operation: getDifferences%3FAFBDAD0340
      virtual ArrayContainer getDifferences (const Fit* fit) const;

      //## Operation: sumSecondDerivs%416D580103BD
      virtual Real sumSecondDerivs (int pi, int pj, bool isPiResp = false, bool isPjResp = false);

      //## Operation: sumDerivs%416D58B802AB
      virtual Real sumDerivs (int parameterIndex, bool isRespar = false);

      //## Operation: calcD2Sigma%416D96420021
      void calcD2Sigma (size_t specNum, RealArray& correction) const;

      //## Operation: adjustForFrozen%448456FA016F
      virtual std::pair<Real,Real> adjustForFrozen (const SpectralData* spec, const std::vector<Model*>& models, const std::map<Model*,ArrayContainer >& savedValsForFrozen);

      //## Operation: applyMinVariance%44999EA1013F
      //	Returns true if any channel's variance required that a
      //	minimum value be added.
      static bool applyMinVariance (const SpectralData* sd, RealArray& variance);

    // Additional Private Declarations
      //## begin ChiSquare%3B7BFB6F0280.private preserve=yes
      //## end ChiSquare%3B7BFB6F0280.private

  private: //## implementation

    //## Other Operations (specified)
      //## Operation: doPerform%3B7BFE0D0311
      virtual void doPerform (Fit* fit);

      //## Operation: doInitialize%3C598E1C0041
      virtual void doInitialize (Fit* fit);

      //## Operation: doDeallocate%3C5AAD6900ED
      virtual void doDeallocate ();

      //## Operation: doReset%3C6BE44E007C
      virtual void doReset (Fit* fit);

    // Data Members for Class Attributes

      //## Attribute: specsWithZeroVarChans%4B06EA8D0126
      //	Contains the 1-based spectrum numbers of any spectra
      //	which required an applied minimum variance during the
      //	most recent doPerform call.
      //## begin ChiSquare::specsWithZeroVarChans%4B06EA8D0126.attr preserve=no  private: std::vector<size_t> {U} 
      std::vector<size_t> m_specsWithZeroVarChans;
      //## end ChiSquare::specsWithZeroVarChans%4B06EA8D0126.attr

    // Data Members for Associations

      //## Association: XSFit::Fit::Observed minus Predicted%3C7D40B6022B
      //## Role: ChiSquare::difference%3C7D40B60282
      //## begin ChiSquare::difference%3C7D40B60282.role preserve=no  private: ArrayContainer { -> 1..nVHgN}
      ArrayContainer m_difference;
      //## end ChiSquare::difference%3C7D40B60282.role

      //## Association: XSFit::Fit::Variance%3C7D40C200D0
      //## Role: ChiSquare::variance%3C7D40C200D1
      //## begin ChiSquare::variance%3C7D40C200D1.role preserve=no  private: ArrayContainer { -> 1..nVHgN}
      ArrayContainer m_variance;
      //## end ChiSquare::variance%3C7D40C200D1.role

      //## Association: XSFit::Fit::<unnamed>%3DD3F21300C6
      //## begin ChiSquare::fullName%3DD3F21400EA.role preserve=no  public: std::string { -> 1VHgN}
      std::string m_fullName;
      //## end ChiSquare::fullName%3DD3F21400EA.role

      //## Association: XSFit::Fit::<unnamed>%3DD4093801A8
      //## begin ChiSquare::scriptName%3DD4093901F4.role preserve=no  public: std::string { -> 1VHgN}
      std::string m_scriptName;
      //## end ChiSquare::scriptName%3DD4093901F4.role

      //## Association: XSFit::Fit::WeightDerivative%416EAFF90171
      //## Role: ChiSquare::dSigma%416EAFFD0239
      //## begin ChiSquare::dSigma%416EAFFD0239.role preserve=no  protected: ArrayContainer { -> 1VHgN}
      ArrayContainer m_dSigma;
      //## end ChiSquare::dSigma%416EAFFD0239.role

    // Additional Implementation Declarations
      //## begin ChiSquare%3B7BFB6F0280.implementation preserve=yes
      //## end ChiSquare%3B7BFB6F0280.implementation

};

//## begin ChiSquare%3B7BFB6F0280.postscript preserve=yes
//## end ChiSquare%3B7BFB6F0280.postscript

// Class ChiSquare 

//## Get and Set Operations for Associations (inline)

inline const std::string& ChiSquare::fullName () const
{
  //## begin ChiSquare::fullName%3DD3F21400EA.get preserve=no
  return m_fullName;
  //## end ChiSquare::fullName%3DD3F21400EA.get
}

inline const std::string& ChiSquare::scriptName () const
{
  //## begin ChiSquare::scriptName%3DD4093901F4.get preserve=no
  return m_scriptName;
  //## end ChiSquare::scriptName%3DD4093901F4.get
}

//## begin module%3C17869E016B.epilog preserve=yes
//## end module%3C17869E016B.epilog


#endif
